// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', [
  'ionic', 
  'starter.controllers', 
  'starter.services', 
  'starter.directives',
  'ngStorage', 
  'ngCordova', 
  'ionicLazyLoad'
])
.run(function($ionicPlatform, $localStorage, $state) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleLightContent();
    }

    if (typeof analytics !== 'undefined') {
      // analytics.debugMode();
      analytics.startTrackerWithId('UA-51440217-2');
      console.log("Google Analytics started");
    } else {
      console.log("Google Analytics not available");
    }

  });

  if (ionic.Platform.isAndroid() && $localStorage.restorePhoto) {
    $state.go('form_view');
  } else {
    $state.go('home');
  }

})

.config(function($ionicConfigProvider, $stateProvider, $urlRouterProvider) {

  $ionicConfigProvider.tabs.position('bottom');

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  .state('home', {
    url: '/home',
    templateUrl: 'templates/home.html',
    controller: 'HomeCtrl'
  })

  .state('gallery', {
    url: '/gallery',
    templateUrl: 'templates/gallery.html',
    controller: 'GalleryCtrl'
  })

  .state('whatsnew', {
    url: '/whatsnew',
    templateUrl: 'templates/changelog.html',
    controller: 'ChangelogCtrl'
  })

  .state('support', {
    url: '/support',
    templateUrl: 'templates/support.html',
    controller: 'SupportCtrl'
  })

  .state('template_view', {
    url: '/template_view',
    templateUrl: 'templates/template.html',
    controller: 'TemplateCtrl'
  })

  .state('form_view', {
    url: '/form_view',
    templateUrl: 'templates/form.html',
    controller: 'FormCtrl'
  })

  .state('finished_view', {
    url: '/finished_view',
    templateUrl: 'templates/finished.html',
    controller: 'FinishedCtrl'
  });

  // if none of the above states are matched, use this as the fallback
  // $urlRouterProvider.otherwise('/home');

});
