angular.module('starter.controllers')
.controller('FormCtrl', function($scope, $ionicPopup, Params, IDs, SavedData, AdHelper) {

  if(typeof analytics !== 'undefined') { analytics.trackView("Fake ID Forms"); }

  var photoDefault = 'img/blue_outline.png';
  var signatureDefault = '<?xml version="1.0" encoding="UTF-8" standalone="no" ?>' +
                          '<!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">' +
                          '<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" width="1" height="1" xml:space="preserve"></svg>';
  var hintPopup;

  $scope.savedData = SavedData.get();
  Params.get().then(setParams);

  $scope.savedData.inputs.photo = $scope.savedData.inputs.photo || photoDefault;
  $scope.savedData.inputs.signature = $scope.savedData.inputs.signature || signatureDefault;
  $scope.savedData.inputs.signaturePNG = $scope.savedData.inputs.signaturePNG || "img/nothing.png";

  $scope.$on('$ionicView.beforeEnter', function(viewInfo, state) {
    IDs.get($scope.savedData.selection + '.json').then(setID);
  });

  $scope.$on('$ionicView.leave', function(viewInfo, state) {
    AdHelper.showInterstitial();
  });

  // A confirm dialog
  $scope.showConfirmDelete = function() {
    var confirmPopup = $ionicPopup.confirm({
      title: 'Start over',
      template: 'Are you sure you want to clear the form and start over?',
      buttons: [
        {
          text: 'Cancel',
          type: 'button-clear'
        },
        {
          text: 'Clear all',
          type: 'button-assertive',
          onTap: function() {
            SavedData.clearInputs();
            $scope.clear('photo');
            $scope.clear('signature');
          }
        }
      ]
    });
  };

  $scope.hintPopup = function(paramName) {
    $scope.tmpHint = $scope.params[paramName];
    $scope.tmpHint.name = paramName;
    console.log($scope.tmpHint);
    hintPopup = $ionicPopup.show({
      title: $scope.tmpHint.label,
      scope: $scope,
      templateUrl: "templates/hint.html",
      buttons: [ {text:"OK", type: "button-positive"} ]
    });
  };

  $scope.applyExample = function(key, val) {
    $scope.savedData.inputs.texts[key] = val;
    hintPopup.close();
  };

  $scope.clear = function(param) {
    if (param == 'photo') {
      $scope.savedData.inputs[param] = photoDefault;
    } else if (param == 'signature') {
      $scope.savedData.inputs[param] = signatureDefault;
      $scope.savedData.inputs.signaturePNG = "img/nothing.png";
    } else {
      $scope.savedData.inputs.texts[param] = "";
    }
  };

  $scope.focusNext = function(index) {
    $('input[tabindex='+ (index+1) +']').focus().select();
  };

  function setID(ID) {
    $scope.ID = ID;
  }

  function setParams(params) {
    $scope.params = params;
  }

});
