angular.module('starter.controllers')
.controller('GalleryCtrl', function($scope, $window, galleryPath, $cordovaFile,
$ionicScrollDelegate, $ionicModal, $ionicSlideBoxDelegate, $cordovaSocialSharing,
$ionicLoading, storePageURL, $ionicPopup) {

  if(typeof analytics !== 'undefined') { analytics.trackView("Fake ID Gallery"); }
  $scope.ios = ionic.Platform.isIOS();

  $scope.$on('$ionicView.enter', function() {
    $scope.mode = "view"; // or 'delete' or 'share'
  });
  $scope.zoomMin = 1;
  $scope.images = [];

  if (ionic.Platform.isAndroid() || ionic.Platform.isIOS()) {
    $window.resolveLocalFileSystemURL(galleryPath, function (fileSystem) {
      var dirReader = fileSystem.createReader();
      dirReader.readEntries(function(results) {
        for (var i = 0; i < results.length; i++) {
          $scope.images.push({
            src: results[i].nativeURL,
            fileName: results[i].name
          });
        }
      });
    });
  } else {
    $scope.images = [
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/300x500" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/500x300" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/300x500" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/500x300" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/300x500" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/500x300" },
      { src: "http://www.placehold.it/500x300" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/300x500" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/500x300" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/300x500" },
      { src: "http://www.placehold.it/300" },
      { src: "http://www.placehold.it/500x300" }
    ];
  }


  $scope.toggleDeleteMode = function() {
    $scope.deleteMode = !$scope.deleteMode;
  };

  $scope.imageClicked = function(index) {
    console.log('mode is set to: ' + $scope.mode);
    if ($scope.mode == 'delete') {
      $cordovaFile.removeFile(galleryPath, $scope.images[index].fileName);
      $scope.images.splice(index, 1);

    } else if ($scope.mode == 'share') {
      $ionicLoading.show({
        templateUrl: "templates/loading.html",
        duration: 10000
      });
      var hideLoading = function() {
        $ionicLoading.hide();
      };
      $cordovaSocialSharing.share(
        null,
        $scope.images[index].fileName,
        $scope.images[index].src,
        null
      ).then(hideLoading, hideLoading);

    } else {
      $scope.showImages(index);
    }
  };

  $scope.isMode = function(mode) {
    return $scope.mode == mode;
  };
  $scope.setMode = function(mode) {
    $scope.mode = mode;
  };

  $scope.showImages = function(index) {
    $scope.activeSlide = index;
    $scope.showModal('templates/gallery-zoomview.html');
  };

  $scope.showModal = function(templateUrl) {
    $ionicModal.fromTemplateUrl(templateUrl, {
      scope: $scope
    }).then(function(modal) {
      $scope.modal = modal;
      $scope.modal.show();
    });
  };

  $scope.closeModal = function() {
    $scope.modal.hide();
    $scope.modal.remove();
  };

  $scope.updateSlideStatus = function(slide) {
    var zoomFactor = $ionicScrollDelegate.$getByHandle('scrollHandle' + slide).getScrollPosition().zoom;
    if (zoomFactor == $scope.zoomMin) {
      $ionicSlideBoxDelegate.enableSlide(true);
    } else {
      $ionicSlideBoxDelegate.enableSlide(false);
    }
  };

  $scope.iosHint = function() {
    $ionicPopup.alert({
      title: "Tip",
      template: "Want to send an image to your <strong>photo reel</strong>? " +
                "<span class='balanced'>Share</span> it and tap " +
                "<span class='balanced'>Save Image</span> in the pop-up."
    });
  };

});
