angular.module('starter.services')
.service('AdHelper', function($timeout, $window, $cordovaGoogleAds) {
  var service = this;
  this.timeUp = true;
  this.adLoaded = false;
  this.interstitialId = (ionic.Platform.isAndroid()) ? "ca-app-pub-4347371255028368/6532857733" :
                        (ionic.Platform.isIOS()) ? "ca-app-pub-4347371255028368/8113774938" :
                        null;

  this.resetTimer = function() {
    service.timeUp = false;
    service.timer = $timeout(function() {
      service.timeUp = true;
      console.log('ad timer is ready');
    }, 120000);
  };

  this.showInterstitial = function() {
    if (service.adLoaded && service.timeUp) {
      $cordovaGoogleAds.showInterstitial();
    } else {
      if (!service.adLoaded) {
        console.log('not showing ad because it isn\'t loaded');
      }
      if (!service.timeUp) {
        console.log('not showing ad because ad timer isn\'t up');
      }
    }
  };

  this.prepareInterstitial = function() {
    if (!service.adLoaded) {
      console.log('preparing ad');
      //add property isTesting: true to enable test ads
      $cordovaGoogleAds.prepareInterstitial({
        adId: service.interstitialId, 
        autoShow: false,
        isTesting: false
      });
    } else {
      console.log('not preparing ad; one is already loaded');
    }
  };

  document.addEventListener('onAdLoaded', function(data) {
    console.log('ad loaded');
    service.adLoaded = true;
  });

  document.addEventListener('onAdFailLoad', function(data) {
    console.log('ad failed to load', data);
    console.log('retrying...');
    service.prepareInterstitial();
  });

  document.addEventListener('onAdDismiss', function(data) {
    console.log('ad closed; loading another');
    service.adLoaded = false;
    service.resetTimer();
    service.prepareInterstitial();
  });

  document.addEventListener("deviceready", function() {
    console.log('device ready to prepare first ad');
    service.prepareInterstitial();
  });

});
